unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, Menus, ExtCtrls, ActnList, StdCtrls, ComCtrls, Buttons;

type
  TwndIconic = class(TForm)
    GroupBox1: TGroupBox;
    lHoraActual: TLabel;
    RadioGroup1: TRadioGroup;
    gAccion: TGroupBox;
    lHora: TLabel;
    Button3: TButton;
    BMinimizar: TButton;
    BAjustar: TButton;
    Button2: TButton;
    actAction: TActionList;
    actAcercaDe: TAction;
    actAyuda: TAction;
    actAjustarHora: TAction;
    actMinimizar: TAction;
    actSalir: TAction;
    Temporizador: TTimer;
    PopupMenu1: TPopupMenu;
    Acercade1: TMenuItem;
    Ayuda1: TMenuItem;
    Ajustarhora1: TMenuItem;
    Minimizar1: TMenuItem;
    Salir1: TMenuItem;
    opApagar: TRadioButton;
    opReiniciar: TRadioButton;
    opReiniciarEquipo: TRadioButton;
    opAviso: TRadioButton;
    BE: TStatusBar;
    actConfiguracion: TAction;
    N1: TMenuItem;
    Configuracin1: TMenuItem;
    N2: TMenuItem;
    LWEB: TLabel;
    Nuev: TLabel;
    GroupBox2: TGroupBox;
    opGuardar: TCheckBox;
    opCapturar: TCheckBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actAcercaDeExecute(Sender: TObject);
    procedure actAjustarHoraExecute(Sender: TObject);
    procedure actMinimizarExecute(Sender: TObject);
    procedure actSalirExecute(Sender: TObject);
    procedure TemporizadorTimer(Sender: TObject);
    procedure opApagarClick(Sender: TObject);
    procedure opApagarDblClick(Sender: TObject);
    procedure opAvisoClick(Sender: TObject);
    procedure opReiniciarClick(Sender: TObject);
    procedure opReiniciarDblClick(Sender: TObject);
    procedure opReiniciarEquipoClick(Sender: TObject);
    procedure opReiniciarEquipoDblClick(Sender: TObject);
    procedure actConfiguracionExecute(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure RealizarProceso ();
    procedure LWEBClick2(Sender: TObject);
  private
    iconificada : boolean;
    FTrayMessage: Cardinal;
    ejecutadoYa : boolean;
    procedure RButtonUp;
    procedure LButtonDblClk;
  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    Hora : TDatetime;{ Public declarations }
    cancelar, realizar : boolean;
    procedure NotifyTray(Command: Word; const Hint: string);
  end;

var
  wndIconic: TwndIconic;

implementation

uses About,  unidadajustarhora, unidadRealizar;

{$R *.DFM}

resourcestring
  STrayMessage = 'PCU 1.0';

procedure TwndIconic.NotifyTray(Command: Word; const Hint: string);
var
  Data: TNotifyIconData;
begin
  Data.cbSize := SizeOf(Data);
  Data.uID := 0;
  Data.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  Data.Wnd := Self.Handle;
  Data.uCallbackMessage := FTrayMessage;
  Data.hIcon := Application.Icon.Handle;
  StrLCopy(Data.szTip, PChar(Hint), SizeOf(Data.szTip));
  Shell_NotifyIcon(Command, @Data);
end;

procedure TwndIconic.WndProc(var Msg: TMessage);
begin
  if Msg.Msg = FTrayMessage then
    case Msg.LParam of
      WM_RBUTTONUP: RButtonUp;
      WM_LBUTTONDBLCLK: LButtonDblClk;
    end
  else
    inherited WndProc(Msg);
end;

procedure TwndIconic.LButtonDblClk;
begin
  with Twndabout.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TwndIconic.RButtonUp;
var
  Pt: TPoint;
begin
  GetCursorPos(Pt);
  SetForegroundWindow(Application.Handle);
  Application.ProcessMessages;
  PopupMenu1.Popup(Pt.X, Pt.Y);
end;

procedure TwndIconic.FormCreate(Sender: TObject);
begin
  realizar := False;
  cancelar := False;
  iconificada := false;
  lhoraactual.Caption := TimeToStr (time);
//  Application.ShowMainForm := False;
//  ShowWindow(Application.Handle, SW_HIDE);
//  FTrayMessage := RegisterWindowMessage(PChar(STrayMessage));
//  NotifyTray(NIM_ADD, Application.Title);
end;

procedure TwndIconic.FormDestroy(Sender: TObject);
begin
  ejecutadoya := false;
  NotifyTray(NIM_DELETE, '');
end;

procedure TwndIconic.actAcercaDeExecute(Sender: TObject);
begin
  with Twndabout.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TwndIconic.actAjustarHoraExecute(Sender: TObject);
begin
  If frmAjustarHora.ShowModal = MrOk Then
  begin
    try
    begin
      Hora := StrToTime(frmAjustarHora.txthora.Text);
      lhora.Caption := frmAjustarHora.txthora.Text;
      actAjustarHora.caption := 'Cambiar hora';
      if opApagar.Checked then
        caption := 'Apagar a las: ' + TimeToStr (hora);
      if opReiniciar.Checked then
        caption := 'Reiniciar a las: ' + TimeToStr (hora);
      if opAviso.Checked then
        caption := 'Aviso a las: ' + TimeToStr (hora);
      ejecutadoya := false;
      temporizador.Enabled := true;
    end;
    except
      messagedlg ('La hora introducida no es correcta.', mterror, [mbok],0);
    end;
  end;
end;

procedure TwndIconic.actMinimizarExecute(Sender: TObject);
begin
  hide;
  actMinimizar.visible := false;
  actConfiguracion.visible := true;
  Application.ShowMainForm := False;
  ShowWindow(Application.Handle, SW_HIDE);
  FTrayMessage := RegisterWindowMessage(PChar(STrayMessage));
  NotifyTray(NIM_ADD, '');
  iconificada := true;
end;


procedure TwndIconic.actSalirExecute(Sender: TObject);
begin
  close;
end;

function GetErrorstring: string;
var
  lz : Cardinal;
  err : array[0..512] of Char;
begin
  lz := GetLastError;
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, lz, 0, @err, 512, nil);
  Result := string(err);
end;

procedure apagarPC;
var
  rl, flgs : Cardinal;
  hToken : Cardinal;
  tkp : TOKEN_PRIVILEGES;
begin
  flgs := 0;
  flgs := flgs or EWX_POWEROFF;
  if Win32Platform = VER_PLATFORM_WIN32_NT then
  begin
    if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES
             or TOKEN_QUERY, hToken) then
      ShowMessage ('No se ha podido abrir el proceso. [' + GetErrorstring + ']')
    else
    begin
      if LookupPrivilegeValue(nil, 'SeShutdownPrivilege', tkp.Privileges[0].Luid) then
      begin
        tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
        tkp.PrivilegeCount           := 1;
        AdjustTokenPrivileges(hToken, False, tkp, 0, nil, rl);
        if GetLastError <> ERROR_SUCCESS then
          ShowMessage('Se ha producido un error al intentar ajustar los privilegios.');
      end
      else
        ShowMessage('No se ha encontrado el valor del privilegio. [' + GetErrorstring + ']');
    end;
    ExitWindowsEx(flgs, 0);
  end;
end;

procedure TwndIconic.RealizarProceso ();
begin
  //apagar
  If (opapagar.checked = True)  Then
  begin
    apagarPC;
  end;
  //cerrar sesin usuario actual
  If (opreiniciar.checked = True)  Then
    ExitWindowsEx (0,0);
  //REINICIAR EQUIPO
  If (opReiniciarEquipo.checked = True)  Then
    ExitWindowsEx (EWX_REBOOT,0);
  //aviso
  If (opaviso.checked = True)  Then
    messagedlg ('Aviso del programa PCU, seguramente tenga algo que hacer...',
        mtwarning, [mbok],0);
  frmRealizando.hacer := false;  
  frmRealizando.Close;
end;

procedure TwndIconic.TemporizadorTimer(Sender: TObject);
Var
 hAlarma,mAlarma : word;
 hActual,mActual : word;
 Milisegundos, Segundos : word;
begin
  lhoraactual.Caption := TimeToStr (time);
  if not ejecutadoYa then
  begin
    DecodeTime(Hora, hAlarma, mAlarma, segundos, Milisegundos);
    DecodeTime(Time, hActual, mActual, segundos, Milisegundos);

    if iconificada then
    begin
      if lhora.Caption <> 'Sin ajustar hora...' then
      begin
        if opapagar.Checked then
          if iconificada then
            NotifyTray(NIM_MODIFY, 'El PC se apagar a las: ' + lHora.Caption);
        if opReiniciar.Checked then
          if iconificada then
            NotifyTray(NIM_MODIFY, 'La sesin se cerrar a las: ' + lHora.Caption);
        if opReiniciarEquipo.Checked then
          if iconificada then
            NotifyTray(NIM_MODIFY, 'El PC se reiniciar a las: ' + lHora.Caption);
        if opAviso.Checked then
          if iconificada then
            NotifyTray(NIM_MODIFY, 'El PC le avisar a las: ' + lHora.Caption);
      end
      else
        NotifyTray(NIM_MODIFY, 'No ha ajustado hora de accin');
    end;

    //apagar
    If (HActual = hAlarma) and (mActual= mAlarma) and
        (opapagar.checked = True)  Then
    Begin
      ejecutadoya := true;
      frmrealizando.lAccion.Caption := 'Se va a APAGAR el equipo...';
      frmrealizando.temporizador.Enabled := true;
      frmrealizando.show;
    end;
    //cerrar sesin usuario actual
    If (HActual = hAlarma) and (mActual= mAlarma) and
        (opreiniciar.checked = True)  Then
    begin
      ejecutadoya := true;
      frmrealizando.lAccion.Caption := 'Se va a CERRAR LA SESIN actual...';
      frmrealizando.temporizador.Enabled := true;
      frmrealizando.show;
    end;
    //REINICIAR EQUIPO
    If (HActual = hAlarma) and (mActual= mAlarma) and
        (opReiniciarEquipo.checked = True)  Then
    begin
      ejecutadoya := true;
      frmrealizando.lAccion.Caption := 'Se va a REINICIAR el equipo...';
      frmrealizando.temporizador.Enabled := true;
      frmrealizando.show;
    end;
    //aviso
    If (HActual = hAlarma) and (mActual= mAlarma) and
        (opaviso.checked = True)  Then
    begin
      ejecutadoya := true;
      temporizador.Enabled := false;
      frmrealizando.lAccion.Caption := 'Se va a AVISAR al usuario...';
      frmrealizando.temporizador.Enabled := true;
      frmrealizando.show;
    end;
  end;
end;


procedure TwndIconic.opApagarClick(Sender: TObject);
begin
  ejecutadoya := false;
  be.Panels[0].Text := 'Accin: APAGAR';
end;

procedure TwndIconic.opApagarDblClick(Sender: TObject);
begin
  ExitWindowsEx (1,0);
end;

procedure TwndIconic.opAvisoClick(Sender: TObject);
begin
  ejecutadoya := false;
  be.Panels[0].Text := 'Accin: AVISO';
end;

procedure TwndIconic.opReiniciarClick(Sender: TObject);
begin
  ejecutadoya := false;
  be.Panels[0].Text := 'Accin: REINICIAR SESIN ACTUAL';
end;

procedure TwndIconic.opReiniciarDblClick(Sender: TObject);
begin
  ExitWindowsEx (0,0);
end;

procedure TwndIconic.opReiniciarEquipoClick(Sender: TObject);
begin
  ejecutadoya := false;
  be.Panels[0].Text := 'Accin: REINICIAR EQUIPO';
end;

procedure TwndIconic.opReiniciarEquipoDblClick(Sender: TObject);
begin
  ExitWindowsEx (EWX_REBOOT,0);
end;

procedure TwndIconic.actConfiguracionExecute(Sender: TObject);
begin
  show;
  actMinimizar.Visible := true;
  iconificada := false;
end;

procedure TwndIconic.BitBtn1Click(Sender: TObject);
begin
  messagedlg ('Hola mundo',mtWarning,[mbok],0);
end;

procedure TwndIconic.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
